@echo off

tasklist /FI "IMAGENAME eq dxwnd.exe" 2>NUL | find /I /N "dxwnd.exe">NUL
if "%ERRORLEVEL%"=="0" goto skip
Powershell start DxWnd
:skip

echo SPWAW Artillery Fix version 2.3 (PowerShell)
REM --------------------------------
REM Steel Panthers World at War artillery screen fix now theoretically supports up to
REM 8-core CPU's or 4-core CPU's with Hyper-Threading.
REM A CPU with more than 8 cores is not supported.
REM --------------------------------
REM SPWAW needs to be run with the last physical CPU core of a multi core processor.
REM First the script finds out the number of physical CPU cores:
REM --------------------------------

wmic cpu get NumberOfCores | find "2" > nul
if %ERRORLEVEL% == 0 goto 2core

wmic cpu get NumberOfCores | find "3" > nul
if %ERRORLEVEL% == 0 goto 3core

wmic cpu get NumberOfCores | find "4" > nul
if %ERRORLEVEL% == 0 goto 4core

wmic cpu get NumberOfCores | find "6" > nul
if %ERRORLEVEL% == 0 goto 6core

wmic cpu get NumberOfCores | find "8" > nul
if %ERRORLEVEL% == 0 goto 8core

REM --------------------------------
REM After finding out the number of CPU cores the script also checks for the presence of additional logical CPU cores.
REM If no additional logical CPU cores are found the game is started with the Affinity value of the last physical CPU core:
REM --------------------------------

REM Affinity 1 value is also good for a Hyper-Threaded single core CPU (e.g. Intel Atom).
echo Single core CPU found.
echo SPWAW started in AFFINITY 1.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=1
exit

:2core
echo 2 CPU cores found.
wmic cpu get NumberOfLogicalProcessors | find "4" > nul
if %ERRORLEVEL% == 0 goto 2coreHT
echo SPWAW started in AFFINITY 2.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=2
exit

REM The only 3 core cpu is AMD Phenom II X3 and it has no Hyper-Threading.
:3core
echo 3 CPU cores found.
echo SPWAW started in AFFINITY 4.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=4
exit

:4core
echo 4 CPU cores found.
wmic cpu get NumberOfLogicalProcessors | find "8" > nul
if %ERRORLEVEL% == 0 goto 4coreHT
echo SPWAW started in AFFINITY 8.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=8
exit

:6core
echo 6 CPU cores found.
echo SPWAW started in AFFINITY 32.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=32
exit

:8core
echo 8 CPU cores found.
echo SPWAW started in AFFINITY 128.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=128
exit

REM --------------------------------
REM If additional logical CPU cores are found the processor is determined to be using Hyper-Threading.
REM In this case the game is started with the second to last CPU core which is the
REM last physical CPU core on an Intel CPU with Hyper-Threading.
REM --------------------------------

:2coreHT
echo Hyper-Threading detected.
echo SPWAW started in AFFINITY 4.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=4
exit

:4coreHT
echo Hyper-Threading detected.
echo SPWAW started in AFFINITY 64.
Powershell start mech.exe 
Powershell $Process = Get-Process mech; $Process.ProcessorAffinity=64
exit
